#include<bits/stdc++.h>
#define maxn 30
using namespace std;

char Maze[maxn][maxn];
bool visit[maxn][maxn];
typedef struct node
{
    int x,y;
    int dis;
    node(int _x=0,int _y=0,int _d=0):x(_x),y(_y),dis(_d){}
}node;
queue<node> Q;
int dir[4][2] = {{0,1},{1,0},{-1,0},{0,-1}};

bool valid(int x,int y,int n){
    int ty = y;
    if(x<0 || x>=n) return false;
    if(y<0 || y>=n) return false;
    if(Maze[x][ty] == '#') return false;
    if(visit[x][y]) return false;
    return true;
}

int bfs(int n)
{
    int i,j,stx,sty,edx,edy,tox,toy;
    bool flag;
    struct node now;
    for(i=0;i<n;i++)
    for(j=0;j<n;j++){
        if(Maze[i][j] == 'S'){
            stx = i; sty = j;
        }
        if(Maze[i][j] == 'E'){
            edx = i; edy = j;
        }
    }
    memset(visit,0,sizeof(visit));
    while(!Q.empty()) Q.pop();
    Q.push(node(stx, sty, 0));
    visit[stx][sty] = true;
    while(!Q.empty()){
        now = Q.front();
        if(now.x == edx && now.y == edy) {
            flag = true;
            break;
        }
        Q.pop();
        for(i=0;i<4;i++){
            tox = now.x + dir[i][0];
            toy = now.y + dir[i][1];
            if(valid(tox,toy,n)){
                Q.push(node(tox,toy,now.dis+1));
                visit[tox][toy] = true;
            }
        }
    }
    if(flag) return now.dis;
    return 1000000;
}

int main()
{
    int T;
    int m,k,ans;
    char tmp[20];
    cin >> T;
    while(T--){
        cin >> m >> k;
        //cin.getline(tmp,100);
        //for(int i=0;i<m;i++) scanf("%s",Maze[i]);
        for(int i=0;i<m;i++) 
        	cin >> Maze[i];
		//cin.getline(Maze[i], 100);
        ans = bfs(m);
        if(ans<=k) cout<<"YES"<<endl;
        else cout<<"NO"<<endl;
    }
    return 0;
}
