#include <iostream>
using namespace std;

int H, W, M;
int a[52][52];

void bfs(int i, int j)
{
	int color = a[i][j];
	a[i][j] = -1;
	if (a[i - 1][j] != -1 && abs(color - a[i - 1][j]) <= M)
		bfs(i - 1, j);
	if (a[i + 1][j] != -1 && abs(color - a[i + 1][j]) <= M)
		bfs(i + 1, j);
	if (a[i][j - 1] != -1 && abs(color - a[i][j - 1]) <= M)
		bfs(i, j - 1);
	if (a[i][j + 1] != -1 && abs(color - a[i][j + 1]) <= M)
		bfs(i, j + 1);
}

int main()
{
	while (cin >> H >> W >> M)
	{
		int count = 0;
		if (H == 0){
			return 0;
		}
		for (int i = 0; i < 52; i++){
			for (int j = 0; j < 52; j++){
				a[i][j] = -1;
			}
		}
		for (int i = 1; i <= H; i++){
			for (int j = 1; j <= W; j++){
				cin >> a[i][j];
			}
		}
		for (int i = 1; i <= H; i++){
			for (int j = 1; j <= W; j++){
				if (a[i][j] != -1){
					count++; 
					bfs(i, j);
				}
			}
		}
		cout << count << endl;
	}
	return 0;
}
