#include<cstdio>
#include<cstdlib>
#include<deque>
using namespace std;
const int dx[4]={0,1,-1,0};
const int dy[4]={1,0,0,-1};
const int inf=1<<30;
int N,M,V;
char mp[105][105];
struct opt
{
	int x,y,v,d; //dǷ 
	opt(){}
	opt(int x,int y,int v,int d):x(x),y(y),v(v),d(d){}
	opt go(int dir){return opt(x+dx[dir],y+dy[dir],v,dir);}
	opt jump(){
		return opt(min(max(0,x+dx[d]*v),N-1), 
				   min(max(0,y+dy[d]*v),M-1),
				   v,d);
	}
	bool valid(){return x>=0&&y>=0&&x<N&&y<M&&mp[x][y]!='#';}
	bool canjump(){return mp[x][y]=='E'&&jump().valid();}
};
struct Arr
{
	int x[105][105][11][4];  //ر Ҳ¼ 
	int& operator[](const opt& X){return x[X.x][X.y][X.v][X.d]; }
	
	void clear(){
		for (int i=0;i<N;++i) 
			for (int j=0;j<M;++j) 
				for (int k=0;k<=V;++k) 
					for(int d=0;d<4;++d) 
						x[i][j][k][d]=inf;}
};
Arr dis;
deque<opt> q;
inline void push(opt x, int d, bool front=1)
{
	//d ǲ 
	if (d<dis[x]) //ûظ  
	{
		dis[x]=d;
		if (front) 
			q.push_front(x);
		else 
			q.push_back(x);
	}
}
void solve(int cas)
{
	int sx,sy,tx,ty;
	for (int i=0;i<N;++i) scanf("%s",mp[i]);
	dis.clear();
	for (int i=0;i<N;++i) for (int j=0;j<M;++j)
	{
		if (mp[i][j]=='S') sx=i,sy=j;
		if (mp[i][j]=='T') tx=i,ty=j;
	}
	opt start(sx,sy,V,0);
	dis[start]=0;
	q.push_back(start);
	while(!q.empty())
	{
		opt o=q.front(); 
		q.pop_front();
		for (int i=0;i<o.v;++i) 
			push(opt(o.x,o.y,i,o.d), dis[o]); // throw ,ڶͷ 
		if (o.canjump()) 
			push(o.jump(), dis[o]); // jump ڶͷ 
		for (int i=0;i<4;++i) 
			if (o.go(i).valid()) 
				push(o.go(i), dis[o]+1, 0); // walk ڶβ 
	}
	int ans=inf;
	for (int i=0;i<4;++i) 
		ans=min(ans, dis[opt(tx,ty,0,i)]);
	if (ans==inf) 
		ans=-1;
	printf("Case #%d: %d\n", cas, ans);
}
int main()
{
	freopen("save.in","r",stdin);
	freopen("save.txt","w",stdout);
	int T=0;
	while(scanf("%d%d%d",&N,&M,&V)&&(N|M|V)) solve(++T);
	return 0;
}
