#include <iostream>
#include <queue>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>

using namespace std;

int K,m,t;
char tmap[11][11];
bool visited[11][11];
int di[4] = {-1,0,0,1};
int dj[4] = {0,-1,1,0};

struct node{
	int pi;
	int pj;
	int step;
};


bool bfs(int sti, int stj, int time)
{
	node st;
	st.pi = sti;
	st.pj = stj;
	st.step = 0;

	queue<node> nodes;
	nodes.push(st);

	while (!nodes.empty())
	{
		node cnode = nodes.front();
		nodes.pop();
		if (tmap[cnode.pi][cnode.pj] == 'E' && cnode.step <= time)
		{
			return true;
		}
		visited[cnode.pi][cnode.pj] = true;
		for (int i = 0; i < 4; i++)
		{
			if (cnode.pi + di[i] >= 0 && cnode.pi + di[i] < m && cnode.pj + dj[i] >= 0 && cnode.pj + dj[i] < m && tmap[cnode.pi + di[i]][cnode.pj + dj[i]] != '#' && !visited[cnode.pi + di[i]][cnode.pj + dj[i]])
			{
				node nnode;
				nnode.pi = cnode.pi + di[i];
				nnode.pj = cnode.pj + dj[i];
				nnode.step = cnode.step + 1;
				nodes.push(nnode);
			}
		}
	}
	return false;
}

int main()
{
	int sti, stj;
	cin >> K;
	while (K--)
	{
		cin >> m >> t;
		memset(tmap,0,sizeof(tmap));
		for (int i = 0; i < m; i++)
		{
				cin >> tmap[i];
			for (int j = 0; j < m; j++)				
				if (tmap[i][j] == 'S')
				{
					sti = i;
					stj = j;
				}
		}
		memset(visited, false, sizeof(visited));
		bfs(sti, stj, t) ? cout << "YES"<<endl :cout<< "NO" << endl;

	}
	//system("pause");
	return 0;
}
